	TITLE	D:\pj64player\pj64player\rsp\memory.c
	.386P
include listing.inc
if @Version gt 510
.model FLAT
else
_TEXT	SEGMENT PARA USE32 PUBLIC 'CODE'
_TEXT	ENDS
_DATA	SEGMENT DWORD USE32 PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT DWORD USE32 PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT DWORD USE32 PUBLIC 'BSS'
_BSS	ENDS
_TLS	SEGMENT DWORD USE32 PUBLIC 'TLS'
_TLS	ENDS
FLAT	GROUP _DATA, CONST, _BSS
	ASSUME	CS: FLAT, DS: FLAT, SS: FLAT
endif
_DATA	SEGMENT
COMM	_NoOfMaps:DWORD
COMM	_MapsCRC:DWORD:020H
COMM	_Table:DWORD
COMM	_RecompCode:DWORD
COMM	_RecompCodeSecondary:DWORD
COMM	_RecompPos:DWORD
COMM	_JumpTables:DWORD
COMM	_JumpTable:DWORD
$SG53108 DB	'Not enough memory for RSP RecompCode!', 00H
	ORG $+2
$SG53113 DB	'Not enough memory for RSP RecompCode Secondary!', 00H
$SG53118 DB	'Not enough memory for Jump Table!', 00H
	ORG $+2
$SG53138 DB	'Used up all the Jump tables in the rsp', 00H
	ORG $+1
$SG53192 DB	'hmmmm.... Problem with:', 0aH, 'RSP_LH_DMEM', 00H
$SG53299 DB	'hmmmm.... Problem with:', 0aH, 'RSP_LW_DMEM', 00H
$SG53312 DB	'Unaligned RSP_LW_IMEM', 00H
	ORG $+2
$SG53377 DB	'Unaligned RSP_SH_DMEM', 00H
	ORG $+2
$SG53489 DB	'hmmmm.... Problem with:', 0aH, 'RSP_SW_DMEM', 00H
_DATA	ENDS
PUBLIC	_AllocateMemory
EXTRN	_DisplayError:NEAR
EXTRN	__imp__VirtualAlloc@16:NEAR
_TEXT	SEGMENT
_AllocateMemory PROC NEAR

; 37   : int AllocateMemory (void) {

	push	ebp
	mov	ebp, esp

; 38   : 	RecompCode=(BYTE *) VirtualAlloc( NULL, 0x00400004, MEM_RESERVE, PAGE_EXECUTE_READWRITE);

	push	64					; 00000040H
	push	8192					; 00002000H
	push	4194308					; 00400004H
	push	0
	call	DWORD PTR __imp__VirtualAlloc@16
	mov	DWORD PTR _RecompCode, eax

; 39   : 	RecompCode=(BYTE *) VirtualAlloc( RecompCode, 0x00400000, MEM_COMMIT, PAGE_EXECUTE_READWRITE);

	push	64					; 00000040H
	push	4096					; 00001000H
	push	4194304					; 00400000H
	mov	eax, DWORD PTR _RecompCode
	push	eax
	call	DWORD PTR __imp__VirtualAlloc@16
	mov	DWORD PTR _RecompCode, eax

; 40   : 	
; 41   : 	if(RecompCode == NULL) {

	cmp	DWORD PTR _RecompCode, 0
	jne	SHORT $L53107

; 42   : 		DisplayError("Not enough memory for RSP RecompCode!");

	push	OFFSET FLAT:$SG53108
	call	_DisplayError
	add	esp, 4

; 43   : 		return FALSE;

	xor	eax, eax
	jmp	$L53102
$L53107:

; 45   : 
; 46   : 	RecompCodeSecondary = (BYTE *)VirtualAlloc( NULL, 0x00200000, MEM_COMMIT, PAGE_EXECUTE_READWRITE );

	push	64					; 00000040H
	push	4096					; 00001000H
	push	2097152					; 00200000H
	push	0
	call	DWORD PTR __imp__VirtualAlloc@16
	mov	DWORD PTR _RecompCodeSecondary, eax

; 47   : 	if(RecompCodeSecondary == NULL) {

	cmp	DWORD PTR _RecompCodeSecondary, 0
	jne	SHORT $L53112

; 48   : 		DisplayError("Not enough memory for RSP RecompCode Secondary!");

	push	OFFSET FLAT:$SG53113
	call	_DisplayError
	add	esp, 4

; 49   : 		return FALSE;

	xor	eax, eax
	jmp	SHORT $L53102
$L53112:

; 51   : 
; 52   : 	JumpTables = (BYTE *)VirtualAlloc( NULL, 0x1000 * MaxMaps, MEM_COMMIT, PAGE_READWRITE );

	push	4
	push	4096					; 00001000H
	push	131072					; 00020000H
	push	0
	call	DWORD PTR __imp__VirtualAlloc@16
	mov	DWORD PTR _JumpTables, eax

; 53   : 	if( JumpTables == NULL ) {  

	cmp	DWORD PTR _JumpTables, 0
	jne	SHORT $L53117

; 54   : 		DisplayError("Not enough memory for Jump Table!");

	push	OFFSET FLAT:$SG53118
	call	_DisplayError
	add	esp, 4

; 55   : 		return FALSE;

	xor	eax, eax
	jmp	SHORT $L53102
$L53117:

; 57   : 
; 58   : 	JumpTable = (void **)JumpTables;

	mov	ecx, DWORD PTR _JumpTables
	mov	DWORD PTR _JumpTable, ecx

; 59   : 	RecompPos = RecompCode;

	mov	edx, DWORD PTR _RecompCode
	mov	DWORD PTR _RecompPos, edx

; 60   : 	NoOfMaps = 0;

	mov	DWORD PTR _NoOfMaps, 0

; 61   : 	return TRUE;

	mov	eax, 1
$L53102:

; 62   : }

	pop	ebp
	ret	0
_AllocateMemory ENDP
_TEXT	ENDS
PUBLIC	_FreeMemory
EXTRN	__imp__VirtualFree@12:NEAR
_TEXT	SEGMENT
_FreeMemory PROC NEAR

; 64   : void FreeMemory (void) {

	push	ebp
	mov	ebp, esp

; 65   : 	VirtualFree( RecompCode, 0 , MEM_RELEASE);

	push	32768					; 00008000H
	push	0
	mov	eax, DWORD PTR _RecompCode
	push	eax
	call	DWORD PTR __imp__VirtualFree@12

; 66   : 	VirtualFree( JumpTable, 0 , MEM_RELEASE);

	push	32768					; 00008000H
	push	0
	mov	ecx, DWORD PTR _JumpTable
	push	ecx
	call	DWORD PTR __imp__VirtualFree@12

; 67   : 	VirtualFree( JumpTables, 0 , MEM_RELEASE);

	push	32768					; 00008000H
	push	0
	mov	edx, DWORD PTR _JumpTables
	push	edx
	call	DWORD PTR __imp__VirtualFree@12

; 68   : 	VirtualFree( RecompCodeSecondary, 0 , MEM_RELEASE);

	push	32768					; 00008000H
	push	0
	mov	eax, DWORD PTR _RecompCodeSecondary
	push	eax
	call	DWORD PTR __imp__VirtualFree@12

; 69   : }

	pop	ebp
	ret	0
_FreeMemory ENDP
_TEXT	ENDS
PUBLIC	_SetJumpTable
EXTRN	__imp__ExitThread@4:NEAR
EXTRN	_RSPInfo:BYTE
_TEXT	SEGMENT
_CRC$ = -4
_count$ = -8
_SetJumpTable PROC NEAR

; 71   : void SetJumpTable (void) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8

; 72   : 	DWORD CRC, count;
; 73   : 
; 74   : 	CRC = 0;

	mov	DWORD PTR _CRC$[ebp], 0

; 75   : 	for (count = 0; count < 0x800; count += 0x40) {

	mov	DWORD PTR _count$[ebp], 0
	jmp	SHORT $L53128
$L53129:
	mov	eax, DWORD PTR _count$[ebp]
	add	eax, 64					; 00000040H
	mov	DWORD PTR _count$[ebp], eax
$L53128:
	cmp	DWORD PTR _count$[ebp], 2048		; 00000800H
	jae	SHORT $L53130

; 76   : 		CRC += *(DWORD *)(RSPInfo.IMEM + count);		

	mov	ecx, DWORD PTR _RSPInfo+16
	add	ecx, DWORD PTR _count$[ebp]
	mov	edx, DWORD PTR _CRC$[ebp]
	add	edx, DWORD PTR [ecx]
	mov	DWORD PTR _CRC$[ebp], edx

; 77   : 	}

	jmp	SHORT $L53129
$L53130:

; 78   : 
; 79   : /*	
; 80   : 	for (count = 0; count < 0x1000; count += 0x4) {
; 81   : 		CRC += *(DWORD *)(RSPInfo.IMEM + count) >> 10;
; 82   : 	}
; 83   : */	
; 84   : 	for (count = 0; count <	NoOfMaps; count++ ) {

	mov	DWORD PTR _count$[ebp], 0
	jmp	SHORT $L53132
$L53133:
	mov	eax, DWORD PTR _count$[ebp]
	add	eax, 1
	mov	DWORD PTR _count$[ebp], eax
$L53132:
	mov	ecx, DWORD PTR _count$[ebp]
	cmp	ecx, DWORD PTR _NoOfMaps
	jae	SHORT $L53134

; 85   : 		if (CRC == MapsCRC[count]) {

	mov	edx, DWORD PTR _count$[ebp]
	mov	eax, DWORD PTR _CRC$[ebp]
	cmp	eax, DWORD PTR _MapsCRC[edx*4]
	jne	SHORT $L53135

; 86   : 			JumpTable = (void **)(JumpTables + count * 0x1000);

	mov	ecx, DWORD PTR _count$[ebp]
	shl	ecx, 12					; 0000000cH
	mov	edx, DWORD PTR _JumpTables
	add	edx, ecx
	mov	DWORD PTR _JumpTable, edx

; 87   : 			Table = count;

	mov	eax, DWORD PTR _count$[ebp]
	mov	DWORD PTR _Table, eax

; 88   : 			return;

	jmp	SHORT $L53125
$L53135:

; 90   : 	}

	jmp	SHORT $L53133
$L53134:

; 91   : 	//DisplayError("%X %X",NoOfMaps,CRC);
; 92   : 	if (NoOfMaps == MaxMaps) {

	cmp	DWORD PTR _NoOfMaps, 32			; 00000020H
	jne	SHORT $L53137

; 93   : 		DisplayError("Used up all the Jump tables in the rsp");

	push	OFFSET FLAT:$SG53138
	call	_DisplayError
	add	esp, 4

; 94   : 		ExitThread(0);

	push	0
	call	DWORD PTR __imp__ExitThread@4
$L53137:

; 96   : 	MapsCRC[NoOfMaps] = CRC;

	mov	ecx, DWORD PTR _NoOfMaps
	mov	edx, DWORD PTR _CRC$[ebp]
	mov	DWORD PTR _MapsCRC[ecx*4], edx

; 97   : 	JumpTable = (void **)(JumpTables + NoOfMaps * 0x1000);

	mov	eax, DWORD PTR _NoOfMaps
	shl	eax, 12					; 0000000cH
	mov	ecx, DWORD PTR _JumpTables
	add	ecx, eax
	mov	DWORD PTR _JumpTable, ecx

; 98   : 	Table = NoOfMaps;

	mov	edx, DWORD PTR _NoOfMaps
	mov	DWORD PTR _Table, edx

; 99   : 	NoOfMaps += 1;

	mov	eax, DWORD PTR _NoOfMaps
	add	eax, 1
	mov	DWORD PTR _NoOfMaps, eax
$L53125:

; 100  : }

	mov	esp, ebp
	pop	ebp
	ret	0
_SetJumpTable ENDP
_TEXT	ENDS
PUBLIC	_RSP_LB_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_LB_DMEM PROC NEAR

; 102  : void RSP_LB_DMEM ( DWORD Addr, BYTE * Value ) {

	push	ebp
	mov	ebp, esp

; 103  : 	* Value = *(BYTE *)(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) ;

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _Value$[ebp]
	mov	edx, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR [edx+eax]
	mov	BYTE PTR [ecx], al

; 104  : }

	pop	ebp
	ret	0
_RSP_LB_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LBV_DMEM
EXTRN	_RSP_Vect:BYTE
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_LBV_DMEM PROC NEAR

; 106  : void RSP_LBV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	esi

; 107  : 	RSP_Vect[vect].B[15 - element] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 15					; 0000000fH
	sub	edx, DWORD PTR _element$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR [esi+eax]
	mov	BYTE PTR _RSP_Vect[ecx+edx], al

; 108  : }

	pop	esi
	pop	ebp
	ret	0
_RSP_LBV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LDV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -8
_RSP_LDV_DMEM PROC NEAR

; 110  : void RSP_LDV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 111  : 	int length, Count;
; 112  : 	
; 113  : 	length = 8;

	mov	DWORD PTR _length$[ebp], 8

; 114  : 	if (length > 16 - element) {

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53165

; 115  : 		length = 16 - element;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53165:

; 117  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], edx
	jmp	SHORT $L53166
$L53167:
	mov	eax, DWORD PTR _Count$[ebp]
	add	eax, 1
	mov	DWORD PTR _Count$[ebp], eax
$L53166:
	mov	ecx, DWORD PTR _length$[ebp]
	add	ecx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], ecx
	jge	SHORT $L53168

; 118  : 		RSP_Vect[vect].B[15 - Count] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _Count$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR [esi+edx]
	mov	BYTE PTR _RSP_Vect[eax+ecx], dl

; 119  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 120  : 	}

	jmp	SHORT $L53167
$L53168:

; 121  : 
; 122  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LDV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LFV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -8
_count$ = -4
_Temp$ = -24
_RSP_LFV_DMEM PROC NEAR

; 124  : void RSP_LFV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 24					; 00000018H

; 125  : 	int length, count;
; 126  : 	VECTOR Temp;
; 127  : 
; 128  : 	length = 8;

	mov	DWORD PTR _length$[ebp], 8

; 129  : 	if (length > 16 - element) {

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53180

; 130  : 		length = 16 - element;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53180:

; 132  : 	
; 133  : 	Temp.HW[7] = *(RSPInfo.DMEM + (((Addr + element) ^3) & 0xFFF)) << 7;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _element$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	WORD PTR _Temp$[ebp+14], cx

; 134  : 	Temp.HW[6] = *(RSPInfo.DMEM + (((Addr + ((0x4 - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	edx, 4
	sub	edx, DWORD PTR _element$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	and	eax, 15					; 0000000fH
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	WORD PTR _Temp$[ebp+12], dx

; 135  : 	Temp.HW[5] = *(RSPInfo.DMEM + (((Addr + ((0x8 - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	eax, 8
	sub	eax, DWORD PTR _element$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	and	ecx, 15					; 0000000fH
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	WORD PTR _Temp$[ebp+10], ax

; 136  : 	Temp.HW[4] = *(RSPInfo.DMEM + (((Addr + ((0xC - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	ecx, 12					; 0000000cH
	sub	ecx, DWORD PTR _element$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	and	edx, 15					; 0000000fH
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	WORD PTR _Temp$[ebp+8], cx

; 137  : 	Temp.HW[3] = *(RSPInfo.DMEM + (((Addr + ((0x8 - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	edx, 8
	sub	edx, DWORD PTR _element$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	and	eax, 15					; 0000000fH
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	WORD PTR _Temp$[ebp+6], dx

; 138  : 	Temp.HW[2] = *(RSPInfo.DMEM + (((Addr + ((0xC - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	eax, 12					; 0000000cH
	sub	eax, DWORD PTR _element$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	and	ecx, 15					; 0000000fH
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	WORD PTR _Temp$[ebp+4], ax

; 139  : 	Temp.HW[1] = *(RSPInfo.DMEM + (((Addr + ((0x10 - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	and	edx, 15					; 0000000fH
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	WORD PTR _Temp$[ebp+2], cx

; 140  : 	Temp.HW[0] = *(RSPInfo.DMEM + (((Addr + ((0x4 - element) ^ 3) & 0xf)) & 0xFFF)) << 7;

	mov	edx, 4
	sub	edx, DWORD PTR _element$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	and	eax, 15					; 0000000fH
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	WORD PTR _Temp$[ebp], dx

; 141  : 	
; 142  : 	for (count = element; count < (length + element); count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _count$[ebp], eax
	jmp	SHORT $L53181
$L53182:
	mov	ecx, DWORD PTR _count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _count$[ebp], ecx
$L53181:
	mov	edx, DWORD PTR _length$[ebp]
	add	edx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _count$[ebp], edx
	jge	SHORT $L53183

; 143  : 		RSP_Vect[vect].B[15 - count] = Temp.B[15 - count];

	mov	eax, 15					; 0000000fH
	sub	eax, DWORD PTR _count$[ebp]
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 15					; 0000000fH
	sub	edx, DWORD PTR _count$[ebp]
	mov	al, BYTE PTR _Temp$[ebp+eax]
	mov	BYTE PTR _RSP_Vect[ecx+edx], al

; 144  : 	}

	jmp	SHORT $L53182
$L53183:

; 145  : }

	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LFV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LH_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_LH_DMEM PROC NEAR

; 147  : void RSP_LH_DMEM ( DWORD Addr, WORD * Value ) {

	push	ebp
	mov	ebp, esp

; 148  : 	if ((Addr & 0x1) != 0) {

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 1
	test	eax, eax
	je	SHORT $L53190

; 149  : 		if (Addr > 0xFFE) {

	cmp	DWORD PTR _Addr$[ebp], 4094		; 00000ffeH
	jbe	SHORT $L53191

; 150  : 			DisplayError("hmmmm.... Problem with:\nRSP_LH_DMEM");

	push	OFFSET FLAT:$SG53192
	call	_DisplayError
	add	esp, 4

; 151  : 			return;

	jmp	SHORT $L53189
$L53191:

; 153  : 		Addr &= 0xFFF;

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 4095				; 00000fffH
	mov	DWORD PTR _Addr$[ebp], ecx

; 154  : 		*Value = *(BYTE *)(RSPInfo.DMEM + (Addr^ 3)) << 8;		

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 8
	mov	edx, DWORD PTR _Value$[ebp]
	mov	WORD PTR [edx], cx

; 155  : 		*Value += *(BYTE *)(RSPInfo.DMEM + ((Addr + 1)^ 3));

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	movzx	dx, BYTE PTR [ecx+eax]
	mov	eax, DWORD PTR _Value$[ebp]
	mov	cx, WORD PTR [eax]
	add	cx, dx
	mov	edx, DWORD PTR _Value$[ebp]
	mov	WORD PTR [edx], cx

; 156  : 		return;

	jmp	SHORT $L53189
$L53190:

; 158  : 	* Value = *(WORD *)(RSPInfo.DMEM + ((Addr ^ 2 ) & 0xFFF));	

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 2
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _Value$[ebp]
	mov	edx, DWORD PTR _RSPInfo+12
	mov	ax, WORD PTR [edx+eax]
	mov	WORD PTR [ecx], ax
$L53189:

; 159  : }

	pop	ebp
	ret	0
_RSP_LH_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LHV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_LHV_DMEM PROC NEAR

; 161  : void RSP_LHV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp

; 162  : 	RSP_Vect[vect].HW[7] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element) & 0xF) ^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+14], ax

; 163  : 	RSP_Vect[vect].HW[6] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 2) & 0xF) ^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 2
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+12], dx

; 164  : 	RSP_Vect[vect].HW[5] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 4) & 0xF) ^3) & 0xFFF)) << 7;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+10], cx

; 165  : 	RSP_Vect[vect].HW[4] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 6) & 0xF) ^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 6
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+8], ax

; 166  : 	RSP_Vect[vect].HW[3] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 8) & 0xF) ^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 8
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+6], dx

; 167  : 	RSP_Vect[vect].HW[2] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 10) & 0xF) ^3) & 0xFFF)) << 7;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 10					; 0000000aH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+4], cx

; 168  : 	RSP_Vect[vect].HW[1] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 12) & 0xF) ^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 12					; 0000000cH
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+2], ax

; 169  : 	RSP_Vect[vect].HW[0] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 14) & 0xF) ^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 14					; 0000000eH
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax], dx

; 170  : }

	pop	ebp
	ret	0
_RSP_LHV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LLV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -8
_RSP_LLV_DMEM PROC NEAR

; 172  : void RSP_LLV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 173  : 	int length, Count;
; 174  : 	
; 175  : 	length = 4;

	mov	DWORD PTR _length$[ebp], 4

; 176  : 	if (length > 16 - element) {

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53214

; 177  : 		length = 16 - element;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53214:

; 179  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], edx
	jmp	SHORT $L53215
$L53216:
	mov	eax, DWORD PTR _Count$[ebp]
	add	eax, 1
	mov	DWORD PTR _Count$[ebp], eax
$L53215:
	mov	ecx, DWORD PTR _length$[ebp]
	add	ecx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], ecx
	jge	SHORT $L53217

; 180  : 		RSP_Vect[vect].B[15 - Count] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _Count$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR [esi+edx]
	mov	BYTE PTR _RSP_Vect[eax+ecx], dl

; 181  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 182  : 	}

	jmp	SHORT $L53216
$L53217:

; 183  : 
; 184  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LLV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LPV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_LPV_DMEM PROC NEAR

; 186  : void RSP_LPV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp

; 187  : 	RSP_Vect[vect].HW[7] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element) & 0xF)^3) & 0xFFF)) << 8;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 8
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+14], ax

; 188  : 	RSP_Vect[vect].HW[6] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 1) & 0xF)^3) & 0xFFF)) << 8;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 1
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 8
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+12], dx

; 189  : 	RSP_Vect[vect].HW[5] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 2) & 0xF)^3) & 0xFFF)) << 8;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 2
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 8
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+10], cx

; 190  : 	RSP_Vect[vect].HW[4] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 3) & 0xF)^3) & 0xFFF)) << 8;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 3
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 8
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+8], ax

; 191  : 	RSP_Vect[vect].HW[3] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 4) & 0xF)^3) & 0xFFF)) << 8;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 8
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+6], dx

; 192  : 	RSP_Vect[vect].HW[2] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 5) & 0xF)^3) & 0xFFF)) << 8;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 5
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 8
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+4], cx

; 193  : 	RSP_Vect[vect].HW[1] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 6) & 0xF)^3) & 0xFFF)) << 8;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 6
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 8
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+2], ax

; 194  : 	RSP_Vect[vect].HW[0] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 7) & 0xF)^3) & 0xFFF)) << 8;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 7
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 8
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax], dx

; 195  : }

	pop	ebp
	ret	0
_RSP_LPV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LRV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -12
_offset$ = -8
_RSP_LRV_DMEM PROC NEAR

; 197  : void RSP_LRV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp
	sub	esp, 12					; 0000000cH
	push	esi

; 198  : 	int length, Count, offset;
; 199  : 
; 200  : 	offset = (Addr & 0xF) - 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 15					; 0000000fH
	sub	eax, 1
	mov	DWORD PTR _offset$[ebp], eax

; 201  : 	length = (Addr & 0xF) - element;

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], ecx

; 202  : 	Addr &= 0xFF0;

	mov	edx, DWORD PTR _Addr$[ebp]
	and	edx, 4080				; 00000ff0H
	mov	DWORD PTR _Addr$[ebp], edx

; 203  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53237
$L53238:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53237:
	mov	edx, DWORD PTR _length$[ebp]
	add	edx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53239

; 204  : 		RSP_Vect[vect].B[offset - Count] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, DWORD PTR _offset$[ebp]
	sub	edx, DWORD PTR _Count$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR [esi+eax]
	mov	BYTE PTR _RSP_Vect[ecx+edx], al

; 205  : 		Addr += 1;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Addr$[ebp], ecx

; 206  : 	}

	jmp	SHORT $L53238
$L53239:

; 207  : 
; 208  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LRV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LQV_DMEM
_TEXT	SEGMENT
_length$ = -4
_Count$ = -8
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_LQV_DMEM PROC NEAR

; 210  : void RSP_LQV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 211  : 	int length, Count;
; 212  : 	
; 213  : 	length = ((Addr + 0x10) & ~0xF) - Addr;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 16					; 00000010H
	and	al, -16					; fffffff0H
	sub	eax, DWORD PTR _Addr$[ebp]
	mov	DWORD PTR _length$[ebp], eax

; 214  : 	if (length > 16 - element) {

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _length$[ebp], ecx
	jle	SHORT $L53250

; 215  : 		length = 16 - element;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], edx
$L53250:

; 217  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53251
$L53252:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53251:
	mov	edx, DWORD PTR _length$[ebp]
	add	edx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53253

; 218  : 		RSP_Vect[vect].B[15 - Count] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 15					; 0000000fH
	sub	edx, DWORD PTR _Count$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR [esi+eax]
	mov	BYTE PTR _RSP_Vect[ecx+edx], al

; 219  : 		Addr += 1;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Addr$[ebp], ecx

; 220  : 	}

	jmp	SHORT $L53252
$L53253:

; 221  : 
; 222  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LQV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LSV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -8
_RSP_LSV_DMEM PROC NEAR

; 224  : void RSP_LSV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 225  : 	int length, Count;
; 226  : 	
; 227  : 	length = 2;

	mov	DWORD PTR _length$[ebp], 2

; 228  : 	if (length > 16 - element) {

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53264

; 229  : 		length = 16 - element;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53264:

; 231  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], edx
	jmp	SHORT $L53265
$L53266:
	mov	eax, DWORD PTR _Count$[ebp]
	add	eax, 1
	mov	DWORD PTR _Count$[ebp], eax
$L53265:
	mov	ecx, DWORD PTR _length$[ebp]
	add	ecx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], ecx
	jge	SHORT $L53267

; 232  : 		RSP_Vect[vect].B[15 - Count] = *(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF));

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _Count$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR [esi+edx]
	mov	BYTE PTR _RSP_Vect[eax+ecx], dl

; 233  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 234  : 	}

	jmp	SHORT $L53266
$L53267:

; 235  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LSV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LTV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_del$ = -12
_count$ = -4
_length$ = -8
_RSP_LTV_DMEM PROC NEAR

; 237  : void RSP_LTV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 12					; 0000000cH
	push	esi

; 238  : 	int del, count, length;
; 239  : 	
; 240  : 	length = 8;

	mov	DWORD PTR _length$[ebp], 8

; 241  : 	if (length > 32 - vect) {

	mov	eax, 32					; 00000020H
	sub	eax, DWORD PTR _vect$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53279

; 242  : 		length = 32 - vect;

	mov	ecx, 32					; 00000020H
	sub	ecx, DWORD PTR _vect$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53279:

; 244  : 	
; 245  : 	Addr = ((Addr + 8) & 0xFF0) + (element & 0x1);	

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 8
	and	edx, 4080				; 00000ff0H
	mov	eax, DWORD PTR _element$[ebp]
	and	eax, 1
	add	edx, eax
	mov	DWORD PTR _Addr$[ebp], edx

; 246  : 	for (count = 0; count < length; count ++) {

	mov	DWORD PTR _count$[ebp], 0
	jmp	SHORT $L53280
$L53281:
	mov	ecx, DWORD PTR _count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _count$[ebp], ecx
$L53280:
	mov	edx, DWORD PTR _count$[ebp]
	cmp	edx, DWORD PTR _length$[ebp]
	jge	SHORT $L53282

; 247  : 		del = ((8 - (element >> 1) + count) << 1) & 0xF;

	mov	eax, DWORD PTR _element$[ebp]
	sar	eax, 1
	mov	ecx, 8
	sub	ecx, eax
	add	ecx, DWORD PTR _count$[ebp]
	shl	ecx, 1
	and	ecx, 15					; 0000000fH
	mov	DWORD PTR _del$[ebp], ecx

; 248  : 		RSP_Vect[vect + count].B[15 - del] = *(RSPInfo.DMEM + (Addr ^ 3));

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _vect$[ebp]
	add	eax, DWORD PTR _count$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _del$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR [esi+edx]
	mov	BYTE PTR _RSP_Vect[eax+ecx], dl

; 249  : 		RSP_Vect[vect + count].B[14 - del] = *(RSPInfo.DMEM + ((Addr + 1) ^ 3));

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	xor	eax, 3
	mov	ecx, DWORD PTR _vect$[ebp]
	add	ecx, DWORD PTR _count$[ebp]
	shl	ecx, 4
	mov	edx, 14					; 0000000eH
	sub	edx, DWORD PTR _del$[ebp]
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR [esi+eax]
	mov	BYTE PTR _RSP_Vect[ecx+edx], al

; 250  : 		Addr += 2;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 2
	mov	DWORD PTR _Addr$[ebp], ecx

; 251  : 	}

	jmp	$L53281
$L53282:

; 252  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_LTV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LUV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_LUV_DMEM PROC NEAR

; 254  : void RSP_LUV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp

; 255  : 	RSP_Vect[vect].HW[7] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element) & 0xF)^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+14], ax

; 256  : 	RSP_Vect[vect].HW[6] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 1) & 0xF)^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 1
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+12], dx

; 257  : 	RSP_Vect[vect].HW[5] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 2) & 0xF)^3) & 0xFFF)) << 7;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 2
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+10], cx

; 258  : 	RSP_Vect[vect].HW[4] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 3) & 0xF)^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 3
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+8], ax

; 259  : 	RSP_Vect[vect].HW[3] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 4) & 0xF)^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax+6], dx

; 260  : 	RSP_Vect[vect].HW[2] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 5) & 0xF)^3) & 0xFFF)) << 7;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _element$[ebp]
	add	ecx, 5
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 7
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	WORD PTR _RSP_Vect[edx+4], cx

; 261  : 	RSP_Vect[vect].HW[1] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 6) & 0xF)^3) & 0xFFF)) << 7;

	mov	eax, 16					; 00000010H
	sub	eax, DWORD PTR _element$[ebp]
	add	eax, 6
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	xor	eax, eax
	mov	al, BYTE PTR [edx+ecx]
	shl	eax, 7
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	WORD PTR _RSP_Vect[ecx+2], ax

; 262  : 	RSP_Vect[vect].HW[0] = *(RSPInfo.DMEM + ((Addr + ((0x10 - element + 7) & 0xF)^3) & 0xFFF)) << 7;

	mov	edx, 16					; 00000010H
	sub	edx, DWORD PTR _element$[ebp]
	add	edx, 7
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 7
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	WORD PTR _RSP_Vect[eax], dx

; 263  : }

	pop	ebp
	ret	0
_RSP_LUV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LW_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_LW_DMEM PROC NEAR

; 265  : void RSP_LW_DMEM ( DWORD Addr, DWORD * Value ) {

	push	ebp
	mov	ebp, esp

; 266  : 	if ((Addr & 0x3) != 0) {

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 3
	test	eax, eax
	je	$L53297

; 267  : 		Addr &= 0xFFF;

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 4095				; 00000fffH
	mov	DWORD PTR _Addr$[ebp], ecx

; 268  : 		if (Addr > 0xFFC) {

	cmp	DWORD PTR _Addr$[ebp], 4092		; 00000ffcH
	jbe	SHORT $L53298

; 269  : 			DisplayError("hmmmm.... Problem with:\nRSP_LW_DMEM");

	push	OFFSET FLAT:$SG53299
	call	_DisplayError
	add	esp, 4

; 270  : 			return;

	jmp	$L53296
$L53298:

; 272  : 		*Value = *(BYTE *)(RSPInfo.DMEM + (Addr^ 3)) << 0x18;

	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	xor	ecx, ecx
	mov	cl, BYTE PTR [eax+edx]
	shl	ecx, 24					; 00000018H
	mov	edx, DWORD PTR _Value$[ebp]
	mov	DWORD PTR [edx], ecx

; 273  : 		*Value += *(BYTE *)(RSPInfo.DMEM + ((Addr + 1)^ 3)) << 0x10;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 16					; 00000010H
	mov	eax, DWORD PTR _Value$[ebp]
	mov	ecx, DWORD PTR [eax]
	add	ecx, edx
	mov	edx, DWORD PTR _Value$[ebp]
	mov	DWORD PTR [edx], ecx

; 274  : 		*Value += *(BYTE *)(RSPInfo.DMEM + ((Addr + 2)^ 3)) << 8;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 2
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	shl	edx, 8
	mov	eax, DWORD PTR _Value$[ebp]
	mov	ecx, DWORD PTR [eax]
	add	ecx, edx
	mov	edx, DWORD PTR _Value$[ebp]
	mov	DWORD PTR [edx], ecx

; 275  : 		*Value += *(BYTE *)(RSPInfo.DMEM + ((Addr + 3)^ 3));

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 3
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	xor	edx, edx
	mov	dl, BYTE PTR [ecx+eax]
	mov	eax, DWORD PTR _Value$[ebp]
	mov	ecx, DWORD PTR [eax]
	add	ecx, edx
	mov	edx, DWORD PTR _Value$[ebp]
	mov	DWORD PTR [edx], ecx

; 276  : 		return;

	jmp	SHORT $L53296
$L53297:

; 278  : 	* Value = *(DWORD *)(RSPInfo.DMEM + (Addr & 0xFFF));	

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _Value$[ebp]
	mov	edx, DWORD PTR _RSPInfo+12
	mov	eax, DWORD PTR [edx+eax]
	mov	DWORD PTR [ecx], eax
$L53296:

; 279  : }

	pop	ebp
	ret	0
_RSP_LW_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_LW_IMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_LW_IMEM PROC NEAR

; 281  : void RSP_LW_IMEM ( DWORD Addr, DWORD * Value ) {

	push	ebp
	mov	ebp, esp

; 282  : 	if ((Addr & 0x3) != 0) {

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 3
	test	eax, eax
	je	SHORT $L53311

; 283  : 		DisplayError("Unaligned RSP_LW_IMEM");

	push	OFFSET FLAT:$SG53312
	call	_DisplayError
	add	esp, 4
$L53311:

; 285  : 	* Value = *(DWORD *)(RSPInfo.IMEM + (Addr & 0xFFF));	

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _Value$[ebp]
	mov	eax, DWORD PTR _RSPInfo+16
	mov	ecx, DWORD PTR [eax+ecx]
	mov	DWORD PTR [edx], ecx

; 286  : }

	pop	ebp
	ret	0
_RSP_LW_IMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SB_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_SB_DMEM PROC NEAR

; 288  : void RSP_SB_DMEM ( DWORD Addr, BYTE Value ) {

	push	ebp
	mov	ebp, esp

; 289  : 	*(BYTE *)(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = Value;

	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR _Value$[ebp]
	mov	BYTE PTR [ecx+eax], dl

; 290  : }

	pop	ebp
	ret	0
_RSP_SB_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SBV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_SBV_DMEM PROC NEAR

; 292  : void RSP_SBV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	esi

; 293  : 	*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].B[15 - element];

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _element$[ebp]
	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR _RSP_Vect[eax+ecx]
	mov	BYTE PTR [esi+edx], al

; 294  : }

	pop	esi
	pop	ebp
	ret	0
_RSP_SBV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SDV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -4
_RSP_SDV_DMEM PROC NEAR

; 296  : void RSP_SDV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	ecx
	push	esi

; 297  : 	int Count;
; 298  : 
; 299  : 	for (Count = element; Count < (8 + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53338
$L53339:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53338:
	mov	edx, DWORD PTR _element$[ebp]
	add	edx, 8
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53340

; 300  : 		*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].B[15 - (Count & 0xF)];

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	and	ecx, 15					; 0000000fH
	mov	edx, 15					; 0000000fH
	sub	edx, ecx
	mov	ecx, DWORD PTR _Addr$[ebp]
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR _RSP_Vect[eax+edx]
	mov	BYTE PTR [esi+ecx], dl

; 301  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 302  : 	}

	jmp	SHORT $L53339
$L53340:

; 303  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SDV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SFV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_offset$ = -4
_RSP_SFV_DMEM PROC NEAR

; 305  : void RSP_SFV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp
	sub	esp, 8

; 306  : 	int offset = Addr & 0xF;

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 15					; 0000000fH
	mov	DWORD PTR _offset$[ebp], eax

; 307  : 	Addr &= 0xFF0;

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 4080				; 00000ff0H
	mov	DWORD PTR _Addr$[ebp], ecx

; 308  : 
; 309  : 	switch (element) {

	mov	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR -8+[ebp], edx
	cmp	DWORD PTR -8+[ebp], 15			; 0000000fH
	ja	$L53351
	mov	eax, DWORD PTR -8+[ebp]
	jmp	DWORD PTR $L53539[eax*4]
$L53354:

; 310  : 	case 0:
; 311  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[7] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+14]
	sar	edx, 7
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 312  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[6] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+12]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 313  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[5] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+10]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 314  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[4] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+8]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 315  : 		break;

	jmp	$L53351
$L53355:

; 316  : 	case 1:
; 317  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[1] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+2]
	sar	eax, 7
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, DWORD PTR _offset$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], al

; 318  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[0] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 319  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[3] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+6]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 8
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 320  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[2] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+4]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 12					; 0000000cH
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 321  : 		break;

	jmp	$L53351
$L53356:

; 322  : 	case 2:
; 323  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 324  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 325  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 8
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 326  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 12					; 0000000cH
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 327  : 		break;

	jmp	$L53351
$L53357:

; 328  : 	case 3:
; 329  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 330  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 331  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 332  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF)^3))) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 333  : 		break;

	jmp	$L53351
$L53358:

; 334  : 	case 4:
; 335  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[6] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+12]
	sar	edx, 7
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 336  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[5] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+10]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 337  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[4] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+8]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 338  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[7] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+14]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 339  : 		break;

	jmp	$L53351
$L53359:

; 340  : 	case 5:
; 341  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[0] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx]
	sar	eax, 7
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, DWORD PTR _offset$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], al

; 342  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[3] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+6]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 343  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[2] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+4]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 8
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 344  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[1] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+2]
	sar	ecx, 7
	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 12					; 0000000cH
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+eax], cl

; 345  : 		break;

	jmp	$L53351
$L53360:

; 346  : 	case 6:
; 347  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 348  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 4
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 349  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 8
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 350  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 12					; 0000000cH
	and	edx, 15					; 0000000fH
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, edx
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], 0

; 351  : 		break;

	jmp	$L53351
$L53361:

; 352  : 	case 7:
; 353  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 354  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 355  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 356  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 357  : 		break;

	jmp	$L53351
$L53362:

; 358  : 	case 8:
; 359  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[3] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+6]
	sar	edx, 7
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 360  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[2] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+4]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 361  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[1] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+2]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 362  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[0] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 363  : 		break;

	jmp	$L53351
$L53363:

; 364  : 	case 9:
; 365  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 366  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 367  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 368  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 369  : 		break;

	jmp	$L53351
$L53364:

; 370  : 	case 10:
; 371  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, DWORD PTR _offset$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 372  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 4
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 373  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 8
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 374  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 12					; 0000000cH
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 375  : 		break;

	jmp	$L53351
$L53365:

; 376  : 	case 11:
; 377  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[4] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+8]
	sar	ecx, 7
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], cl

; 378  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[7] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+14]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 4
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl

; 379  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[6] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+12]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 8
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl

; 380  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[5] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+10]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 12					; 0000000cH
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl

; 381  : 		break;

	jmp	$L53351
$L53366:

; 382  : 	case 12:
; 383  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[2] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+4]
	sar	edx, 7
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, DWORD PTR _offset$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 384  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[1] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+2]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 385  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[0] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 386  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[3] >> 7;

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	mov	ax, WORD PTR _RSP_Vect[edx+6]
	sar	eax, 7
	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+edx], al

; 387  : 		break;

	jmp	$L53351
$L53367:

; 388  : 	case 13:
; 389  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 390  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 4
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 391  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 8
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 392  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	ecx, DWORD PTR _offset$[ebp]
	add	ecx, 12					; 0000000cH
	and	ecx, 15					; 0000000fH
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, ecx
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], 0

; 393  : 		break;

	jmp	$L53351
$L53368:

; 394  : 	case 14:
; 395  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = 0;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, DWORD PTR _offset$[ebp]
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 396  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 4
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 397  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 8
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 398  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = 0;

	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 12					; 0000000cH
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], 0

; 399  : 		break;

	jmp	$L53351
$L53369:

; 400  : 	case 15:
; 401  : 		*(RSPInfo.DMEM + ((Addr + offset)^3)) = RSP_Vect[vect].UHW[7] >> 7;

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	xor	ecx, ecx
	mov	cx, WORD PTR _RSP_Vect[eax+14]
	sar	ecx, 7
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, DWORD PTR _offset$[ebp]
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], cl

; 402  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 4) & 0xF))^3)) = RSP_Vect[vect].UHW[6] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+12]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 4
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl

; 403  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 8) & 0xF))^3)) = RSP_Vect[vect].UHW[5] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+10]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 8
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl

; 404  : 		*(RSPInfo.DMEM + ((Addr + ((offset + 12) & 0xF))^3)) = RSP_Vect[vect].UHW[4] >> 7;

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	xor	edx, edx
	mov	dx, WORD PTR _RSP_Vect[ecx+8]
	sar	edx, 7
	mov	eax, DWORD PTR _offset$[ebp]
	add	eax, 12					; 0000000cH
	and	eax, 15					; 0000000fH
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, eax
	xor	ecx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+ecx], dl
$L53351:

; 407  : }

	mov	esp, ebp
	pop	ebp
	ret	0
$L53539:
	DD	$L53354
	DD	$L53355
	DD	$L53356
	DD	$L53357
	DD	$L53358
	DD	$L53359
	DD	$L53360
	DD	$L53361
	DD	$L53362
	DD	$L53363
	DD	$L53364
	DD	$L53365
	DD	$L53366
	DD	$L53367
	DD	$L53368
	DD	$L53369
_RSP_SFV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SH_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_SH_DMEM PROC NEAR

; 409  : void RSP_SH_DMEM ( DWORD Addr, WORD Value ) {

	push	ebp
	mov	ebp, esp

; 410  : 	if ((Addr & 0x1) != 0) {

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 1
	test	eax, eax
	je	SHORT $L53376

; 411  : 		DisplayError("Unaligned RSP_SH_DMEM");

	push	OFFSET FLAT:$SG53377
	call	_DisplayError
	add	esp, 4

; 412  : 		return;

	jmp	SHORT $L53375
$L53376:

; 414  : 	*(WORD *)(RSPInfo.DMEM + ((Addr ^ 2) & 0xFFF)) = Value;

	mov	ecx, DWORD PTR _Addr$[ebp]
	xor	ecx, 2
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	mov	ax, WORD PTR _Value$[ebp]
	mov	WORD PTR [edx+ecx], ax
$L53375:

; 415  : }

	pop	ebp
	ret	0
_RSP_SH_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SHV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_RSP_SHV_DMEM PROC NEAR

; 417  : void RSP_SHV_DMEM ( DWORD Addr, int vect, int element ) {	

	push	ebp
	mov	ebp, esp
	push	ebx

; 418  : 	*(RSPInfo.DMEM + ((Addr^3) & 0xFFF)) = (RSP_Vect[vect].UB[(15 - element) & 0xF] << 1) + 
; 419  : 		(RSP_Vect[vect].UB[(14 - element) & 0xF] >> 7);

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	edx, edx
	mov	dl, BYTE PTR _RSP_Vect[eax+ecx]
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 14					; 0000000eH
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[eax+ecx]
	sar	ebx, 7
	lea	edx, DWORD PTR [ebx+edx*2]
	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 420  : 	*(RSPInfo.DMEM + (((Addr + 2)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(13 - element) & 0xF] << 1) + 
; 421  : 		(RSP_Vect[vect].UB[(12 - element) & 0xF] >> 7);

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, 13					; 0000000dH
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ecx, ecx
	mov	cl, BYTE PTR _RSP_Vect[edx+eax]
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, 12					; 0000000cH
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[edx+eax]
	sar	ebx, 7
	lea	ecx, DWORD PTR [ebx+ecx*2]
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 2
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], cl

; 422  : 	*(RSPInfo.DMEM + (((Addr + 4)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(11 - element) & 0xF] << 1) + 
; 423  : 		(RSP_Vect[vect].UB[(10 - element) & 0xF] >> 7);

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 11					; 0000000bH
	sub	edx, DWORD PTR _element$[ebp]
	and	edx, 15					; 0000000fH
	xor	eax, eax
	mov	al, BYTE PTR _RSP_Vect[ecx+edx]
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 10					; 0000000aH
	sub	edx, DWORD PTR _element$[ebp]
	and	edx, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[ecx+edx]
	sar	ebx, 7
	lea	eax, DWORD PTR [ebx+eax*2]
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 4
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], al

; 424  : 	*(RSPInfo.DMEM + (((Addr + 6)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(9 - element) & 0xF] << 1) + 
; 425  : 		(RSP_Vect[vect].UB[(8 - element) & 0xF] >> 7);

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 9
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	edx, edx
	mov	dl, BYTE PTR _RSP_Vect[eax+ecx]
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 8
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[eax+ecx]
	sar	ebx, 7
	lea	edx, DWORD PTR [ebx+edx*2]
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 6
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 426  : 	*(RSPInfo.DMEM + (((Addr + 8)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(7 - element) & 0xF] << 1) + 
; 427  : 		(RSP_Vect[vect].UB[(6 - element) & 0xF] >> 7);

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, 7
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ecx, ecx
	mov	cl, BYTE PTR _RSP_Vect[edx+eax]
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, 6
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[edx+eax]
	sar	ebx, 7
	lea	ecx, DWORD PTR [ebx+ecx*2]
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 8
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], cl

; 428  : 	*(RSPInfo.DMEM + (((Addr + 10)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(5 - element) & 0xF] << 1) + 
; 429  : 		(RSP_Vect[vect].UB[(4 - element) & 0xF] >> 7);

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 5
	sub	edx, DWORD PTR _element$[ebp]
	and	edx, 15					; 0000000fH
	xor	eax, eax
	mov	al, BYTE PTR _RSP_Vect[ecx+edx]
	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, 4
	sub	edx, DWORD PTR _element$[ebp]
	and	edx, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[ecx+edx]
	sar	ebx, 7
	lea	eax, DWORD PTR [ebx+eax*2]
	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 10					; 0000000aH
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	edx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [edx+ecx], al

; 430  : 	*(RSPInfo.DMEM + (((Addr + 12)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(3 - element) & 0xF] << 1) + 
; 431  : 		(RSP_Vect[vect].UB[(2 - element) & 0xF] >> 7);

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 3
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	edx, edx
	mov	dl, BYTE PTR _RSP_Vect[eax+ecx]
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, 2
	sub	ecx, DWORD PTR _element$[ebp]
	and	ecx, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[eax+ecx]
	sar	ebx, 7
	lea	edx, DWORD PTR [ebx+edx*2]
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 12					; 0000000cH
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 432  : 	*(RSPInfo.DMEM + (((Addr + 14)^3) & 0xFFF)) = (RSP_Vect[vect].UB[(1 - element) & 0xF] << 1) + 
; 433  : 		(RSP_Vect[vect].UB[(0 - element) & 0xF] >> 7);

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, 1
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ecx, ecx
	mov	cl, BYTE PTR _RSP_Vect[edx+eax]
	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	xor	eax, eax
	sub	eax, DWORD PTR _element$[ebp]
	and	eax, 15					; 0000000fH
	xor	ebx, ebx
	mov	bl, BYTE PTR _RSP_Vect[edx+eax]
	sar	ebx, 7
	lea	ecx, DWORD PTR [ebx+ecx*2]
	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 14					; 0000000eH
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	eax, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [eax+edx], cl

; 434  : }

	pop	ebx
	pop	ebp
	ret	0
_RSP_SHV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SLV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -4
_RSP_SLV_DMEM PROC NEAR

; 436  : void RSP_SLV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	ecx
	push	esi

; 437  : 	int Count;
; 438  : 
; 439  : 	for (Count = element; Count < (4 + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53396
$L53397:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53396:
	mov	edx, DWORD PTR _element$[ebp]
	add	edx, 4
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53398

; 440  : 		*(RSPInfo.DMEM + ((Addr ^3) & 0xFFF)) = RSP_Vect[vect].B[15 - (Count & 0xF)];

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	and	ecx, 15					; 0000000fH
	mov	edx, 15					; 0000000fH
	sub	edx, ecx
	mov	ecx, DWORD PTR _Addr$[ebp]
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR _RSP_Vect[eax+edx]
	mov	BYTE PTR [esi+ecx], dl

; 441  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 442  : 	}

	jmp	SHORT $L53397
$L53398:

; 443  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SLV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SPV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -4
_RSP_SPV_DMEM PROC NEAR

; 445  : void RSP_SPV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	ecx
	push	esi

; 446  : 	int Count;
; 447  : 
; 448  : 	for (Count = element; Count < (8 + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53408
$L53409:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53408:
	mov	edx, DWORD PTR _element$[ebp]
	add	edx, 8
	cmp	DWORD PTR _Count$[ebp], edx
	jge	$L53410

; 449  : 		if (((Count) & 0xF) < 8) {

	mov	eax, DWORD PTR _Count$[ebp]
	and	eax, 15					; 0000000fH
	cmp	eax, 8
	jge	SHORT $L53411

; 450  : 			*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].UB[15 - ((Count & 0xF) << 1)];

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, DWORD PTR _Count$[ebp]
	and	edx, 15					; 0000000fH
	shl	edx, 1
	mov	eax, 15					; 0000000fH
	sub	eax, edx
	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR _RSP_Vect[ecx+eax]
	mov	BYTE PTR [esi+edx], al

; 451  : 		} else {

	jmp	SHORT $L53412
$L53411:

; 452  : 			*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = (RSP_Vect[vect].UB[15 - ((Count & 0x7) << 1)] << 1) +
; 453  : 				(RSP_Vect[vect].UB[14 - ((Count & 0x7) << 1)] >> 7);

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, DWORD PTR _Count$[ebp]
	and	edx, 7
	shl	edx, 1
	mov	eax, 15					; 0000000fH
	sub	eax, edx
	xor	edx, edx
	mov	dl, BYTE PTR _RSP_Vect[ecx+eax]
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	and	ecx, 7
	shl	ecx, 1
	mov	esi, 14					; 0000000eH
	sub	esi, ecx
	xor	ecx, ecx
	mov	cl, BYTE PTR _RSP_Vect[eax+esi]
	sar	ecx, 7
	lea	edx, DWORD PTR [ecx+edx*2]
	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl
$L53412:

; 455  : 		Addr += 1;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 1
	mov	DWORD PTR _Addr$[ebp], edx

; 456  : 	}

	jmp	$L53409
$L53410:

; 457  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SPV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SQV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -8
_RSP_SQV_DMEM PROC NEAR

; 459  : void RSP_SQV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 460  : 	int length, Count;
; 461  : 	
; 462  : 	length = ((Addr + 0x10) & ~0xF) - Addr;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 16					; 00000010H
	and	al, -16					; fffffff0H
	sub	eax, DWORD PTR _Addr$[ebp]
	mov	DWORD PTR _length$[ebp], eax

; 463  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	ecx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], ecx
	jmp	SHORT $L53423
$L53424:
	mov	edx, DWORD PTR _Count$[ebp]
	add	edx, 1
	mov	DWORD PTR _Count$[ebp], edx
$L53423:
	mov	eax, DWORD PTR _length$[ebp]
	add	eax, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], eax
	jge	SHORT $L53425

; 464  : 		*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].B[15 - (Count & 0xF)];

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, DWORD PTR _Count$[ebp]
	and	edx, 15					; 0000000fH
	mov	eax, 15					; 0000000fH
	sub	eax, edx
	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR _RSP_Vect[ecx+eax]
	mov	BYTE PTR [esi+edx], al

; 465  : 		Addr += 1;

	mov	ecx, DWORD PTR _Addr$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Addr$[ebp], ecx

; 466  : 	}

	jmp	SHORT $L53424
$L53425:

; 467  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SQV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SRV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_length$ = -4
_Count$ = -12
_offset$ = -8
_RSP_SRV_DMEM PROC NEAR

; 469  : void RSP_SRV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 12					; 0000000cH
	push	esi

; 470  : 	int length, Count, offset;
; 471  : 
; 472  : 	length = (Addr & 0xF);

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 15					; 0000000fH
	mov	DWORD PTR _length$[ebp], eax

; 473  : 	offset = (0x10 - length) & 0xF;

	mov	ecx, 16					; 00000010H
	sub	ecx, DWORD PTR _length$[ebp]
	and	ecx, 15					; 0000000fH
	mov	DWORD PTR _offset$[ebp], ecx

; 474  : 	Addr &= 0xFF0;

	mov	edx, DWORD PTR _Addr$[ebp]
	and	edx, 4080				; 00000ff0H
	mov	DWORD PTR _Addr$[ebp], edx

; 475  : 	for (Count = element; Count < (length + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53437
$L53438:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53437:
	mov	edx, DWORD PTR _length$[ebp]
	add	edx, DWORD PTR _element$[ebp]
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53439

; 476  : 		*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].B[15 - ((Count + offset) & 0xF)];

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, DWORD PTR _offset$[ebp]
	and	ecx, 15					; 0000000fH
	mov	edx, 15					; 0000000fH
	sub	edx, ecx
	mov	ecx, DWORD PTR _Addr$[ebp]
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR _RSP_Vect[eax+edx]
	mov	BYTE PTR [esi+ecx], dl

; 477  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 478  : 	}

	jmp	SHORT $L53438
$L53439:

; 479  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SRV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SSV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -4
_RSP_SSV_DMEM PROC NEAR

; 481  : void RSP_SSV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	ecx
	push	esi

; 482  : 	int Count;
; 483  : 
; 484  : 	for (Count = element; Count < (2 + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53449
$L53450:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53449:
	mov	edx, DWORD PTR _element$[ebp]
	add	edx, 2
	cmp	DWORD PTR _Count$[ebp], edx
	jge	SHORT $L53451

; 485  : 		*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].B[15 - (Count & 0xF)];

	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	and	ecx, 15					; 0000000fH
	mov	edx, 15					; 0000000fH
	sub	edx, ecx
	mov	ecx, DWORD PTR _Addr$[ebp]
	xor	ecx, 3
	and	ecx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	dl, BYTE PTR _RSP_Vect[eax+edx]
	mov	BYTE PTR [esi+ecx], dl

; 486  : 		Addr += 1;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	mov	DWORD PTR _Addr$[ebp], eax

; 487  : 	}

	jmp	SHORT $L53450
$L53451:

; 488  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SSV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_STV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_del$ = -12
_count$ = -4
_length$ = -8
_RSP_STV_DMEM PROC NEAR

; 490  : void RSP_STV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 12					; 0000000cH
	push	esi

; 491  : 	int del, count, length;
; 492  : 	
; 493  : 	length = 8;

	mov	DWORD PTR _length$[ebp], 8

; 494  : 	if (length > 32 - vect) {

	mov	eax, 32					; 00000020H
	sub	eax, DWORD PTR _vect$[ebp]
	cmp	DWORD PTR _length$[ebp], eax
	jle	SHORT $L53463

; 495  : 		length = 32 - vect;

	mov	ecx, 32					; 00000020H
	sub	ecx, DWORD PTR _vect$[ebp]
	mov	DWORD PTR _length$[ebp], ecx
$L53463:

; 497  : 	length = length << 1;

	mov	edx, DWORD PTR _length$[ebp]
	shl	edx, 1
	mov	DWORD PTR _length$[ebp], edx

; 498  : 	del = element >> 1;

	mov	eax, DWORD PTR _element$[ebp]
	sar	eax, 1
	mov	DWORD PTR _del$[ebp], eax

; 499  : 	for (count = 0; count < length; count += 2) {

	mov	DWORD PTR _count$[ebp], 0
	jmp	SHORT $L53464
$L53465:
	mov	ecx, DWORD PTR _count$[ebp]
	add	ecx, 2
	mov	DWORD PTR _count$[ebp], ecx
$L53464:
	mov	edx, DWORD PTR _count$[ebp]
	cmp	edx, DWORD PTR _length$[ebp]
	jge	SHORT $L53466

; 500  : 		*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect + del].UB[15 - count];

	mov	eax, DWORD PTR _vect$[ebp]
	add	eax, DWORD PTR _del$[ebp]
	shl	eax, 4
	mov	ecx, 15					; 0000000fH
	sub	ecx, DWORD PTR _count$[ebp]
	mov	edx, DWORD PTR _Addr$[ebp]
	xor	edx, 3
	and	edx, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	al, BYTE PTR _RSP_Vect[eax+ecx]
	mov	BYTE PTR [esi+edx], al

; 501  : 		*(RSPInfo.DMEM + (((Addr + 1) ^ 3) & 0xFFF)) = RSP_Vect[vect + del].UB[14 - count];

	mov	ecx, DWORD PTR _vect$[ebp]
	add	ecx, DWORD PTR _del$[ebp]
	shl	ecx, 4
	mov	edx, 14					; 0000000eH
	sub	edx, DWORD PTR _count$[ebp]
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	cl, BYTE PTR _RSP_Vect[ecx+edx]
	mov	BYTE PTR [esi+eax], cl

; 502  : 		del = (del + 1) & 7;

	mov	edx, DWORD PTR _del$[ebp]
	add	edx, 1
	and	edx, 7
	mov	DWORD PTR _del$[ebp], edx

; 503  : 		Addr += 2;

	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 2
	mov	DWORD PTR _Addr$[ebp], eax

; 504  : 	}

	jmp	$L53465
$L53466:

; 505  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_STV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SUV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -4
_RSP_SUV_DMEM PROC NEAR

; 507  : void RSP_SUV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	push	ecx
	push	esi

; 508  : 	int Count;
; 509  : 
; 510  : 	for (Count = element; Count < (8 + element); Count ++ ){

	mov	eax, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], eax
	jmp	SHORT $L53476
$L53477:
	mov	ecx, DWORD PTR _Count$[ebp]
	add	ecx, 1
	mov	DWORD PTR _Count$[ebp], ecx
$L53476:
	mov	edx, DWORD PTR _element$[ebp]
	add	edx, 8
	cmp	DWORD PTR _Count$[ebp], edx
	jge	$L53478

; 511  : 		if (((Count) & 0xF) < 8) {

	mov	eax, DWORD PTR _Count$[ebp]
	and	eax, 15					; 0000000fH
	cmp	eax, 8
	jge	SHORT $L53479

; 512  : 			*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = (RSP_Vect[vect].UB[15 - ((Count & 0x7) << 1)] << 1) +
; 513  : 				(RSP_Vect[vect].UB[14 - ((Count & 0x7) << 1)] >> 7);

	mov	ecx, DWORD PTR _vect$[ebp]
	shl	ecx, 4
	mov	edx, DWORD PTR _Count$[ebp]
	and	edx, 7
	shl	edx, 1
	mov	eax, 15					; 0000000fH
	sub	eax, edx
	xor	edx, edx
	mov	dl, BYTE PTR _RSP_Vect[ecx+eax]
	mov	eax, DWORD PTR _vect$[ebp]
	shl	eax, 4
	mov	ecx, DWORD PTR _Count$[ebp]
	and	ecx, 7
	shl	ecx, 1
	mov	esi, 14					; 0000000eH
	sub	esi, ecx
	xor	ecx, ecx
	mov	cl, BYTE PTR _RSP_Vect[eax+esi]
	sar	ecx, 7
	lea	edx, DWORD PTR [ecx+edx*2]
	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 514  : 		} else {

	jmp	SHORT $L53480
$L53479:

; 515  : 			*(RSPInfo.DMEM + ((Addr ^ 3) & 0xFFF)) = RSP_Vect[vect].UB[15 - ((Count & 0x7) << 1)];

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, DWORD PTR _Count$[ebp]
	and	eax, 7
	shl	eax, 1
	mov	ecx, 15					; 0000000fH
	sub	ecx, eax
	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	and	eax, 4095				; 00000fffH
	mov	esi, DWORD PTR _RSPInfo+12
	mov	cl, BYTE PTR _RSP_Vect[edx+ecx]
	mov	BYTE PTR [esi+eax], cl
$L53480:

; 517  : 		Addr += 1;

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 1
	mov	DWORD PTR _Addr$[ebp], edx

; 518  : 	}

	jmp	$L53477
$L53478:

; 519  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SUV_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SW_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_Value$ = 12
_RSP_SW_DMEM PROC NEAR

; 521  : void RSP_SW_DMEM ( DWORD Addr, DWORD Value ) {

	push	ebp
	mov	ebp, esp

; 522  : 	Addr &= 0xFFF;

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 4095				; 00000fffH
	mov	DWORD PTR _Addr$[ebp], eax

; 523  : 	if ((Addr & 0x3) != 0) {

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 3
	test	ecx, ecx
	je	SHORT $L53487

; 524  : 		if (Addr > 0xFFC) {

	cmp	DWORD PTR _Addr$[ebp], 4092		; 00000ffcH
	jbe	SHORT $L53488

; 525  : 			DisplayError("hmmmm.... Problem with:\nRSP_SW_DMEM");

	push	OFFSET FLAT:$SG53489
	call	_DisplayError
	add	esp, 4

; 526  : 			return;

	jmp	SHORT $L53486
$L53488:

; 528  : 		*(BYTE *)(RSPInfo.DMEM + (Addr ^ 3)) = (BYTE)(Value >> 0x18);

	mov	edx, DWORD PTR _Value$[ebp]
	shr	edx, 24					; 00000018H
	mov	eax, DWORD PTR _Addr$[ebp]
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 529  : 		*(BYTE *)(RSPInfo.DMEM + ((Addr + 1) ^ 3)) = (BYTE)(Value >> 0x10);

	mov	edx, DWORD PTR _Value$[ebp]
	shr	edx, 16					; 00000010H
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 1
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 530  : 		*(BYTE *)(RSPInfo.DMEM + ((Addr + 2) ^ 3)) = (BYTE)(Value >> 0x8);

	mov	edx, DWORD PTR _Value$[ebp]
	shr	edx, 8
	mov	eax, DWORD PTR _Addr$[ebp]
	add	eax, 2
	xor	eax, 3
	mov	ecx, DWORD PTR _RSPInfo+12
	mov	BYTE PTR [ecx+eax], dl

; 531  : 		*(BYTE *)(RSPInfo.DMEM + ((Addr + 3) ^ 3)) = (BYTE)(Value);

	mov	edx, DWORD PTR _Addr$[ebp]
	add	edx, 3
	xor	edx, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	cl, BYTE PTR _Value$[ebp]
	mov	BYTE PTR [eax+edx], cl

; 532  : 		return;

	jmp	SHORT $L53486
$L53487:

; 534  : 	*(DWORD *)(RSPInfo.DMEM + Addr) = Value;

	mov	edx, DWORD PTR _RSPInfo+12
	add	edx, DWORD PTR _Addr$[ebp]
	mov	eax, DWORD PTR _Value$[ebp]
	mov	DWORD PTR [edx], eax
$L53486:

; 535  : }

	pop	ebp
	ret	0
_RSP_SW_DMEM ENDP
_TEXT	ENDS
PUBLIC	_RSP_SWV_DMEM
_TEXT	SEGMENT
_Addr$ = 8
_vect$ = 12
_element$ = 16
_Count$ = -8
_offset$ = -4
_RSP_SWV_DMEM PROC NEAR

; 537  : void RSP_SWV_DMEM ( DWORD Addr, int vect, int element ) {

	push	ebp
	mov	ebp, esp
	sub	esp, 8
	push	esi

; 538  : 	int Count, offset;
; 539  : 
; 540  : 	offset = Addr & 0xF;

	mov	eax, DWORD PTR _Addr$[ebp]
	and	eax, 15					; 0000000fH
	mov	DWORD PTR _offset$[ebp], eax

; 541  : 	Addr &= 0xFF0;

	mov	ecx, DWORD PTR _Addr$[ebp]
	and	ecx, 4080				; 00000ff0H
	mov	DWORD PTR _Addr$[ebp], ecx

; 542  : 	for (Count = element; Count < (16 + element); Count ++ ){

	mov	edx, DWORD PTR _element$[ebp]
	mov	DWORD PTR _Count$[ebp], edx
	jmp	SHORT $L53509
$L53510:
	mov	eax, DWORD PTR _Count$[ebp]
	add	eax, 1
	mov	DWORD PTR _Count$[ebp], eax
$L53509:
	mov	ecx, DWORD PTR _element$[ebp]
	add	ecx, 16					; 00000010H
	cmp	DWORD PTR _Count$[ebp], ecx
	jge	SHORT $L53511

; 543  : 		*(RSPInfo.DMEM + ((Addr + (offset & 0xF)) ^ 3)) = RSP_Vect[vect].B[15 - (Count & 0xF)];

	mov	edx, DWORD PTR _vect$[ebp]
	shl	edx, 4
	mov	eax, DWORD PTR _Count$[ebp]
	and	eax, 15					; 0000000fH
	mov	ecx, 15					; 0000000fH
	sub	ecx, eax
	mov	eax, DWORD PTR _offset$[ebp]
	and	eax, 15					; 0000000fH
	mov	esi, DWORD PTR _Addr$[ebp]
	add	esi, eax
	xor	esi, 3
	mov	eax, DWORD PTR _RSPInfo+12
	mov	cl, BYTE PTR _RSP_Vect[edx+ecx]
	mov	BYTE PTR [eax+esi], cl

; 544  : 		offset += 1;

	mov	edx, DWORD PTR _offset$[ebp]
	add	edx, 1
	mov	DWORD PTR _offset$[ebp], edx

; 545  : 	}

	jmp	SHORT $L53510
$L53511:

; 546  : }

	pop	esi
	mov	esp, ebp
	pop	ebp
	ret	0
_RSP_SWV_DMEM ENDP
_TEXT	ENDS
END
