; 64th.nsi
; this script will install 64th note in the proper locations.

; based on waplugin.nsi example
;

;--------------------------------

; The name of the installer
Name "64th Note v0.05 plug-in"

; The file to write
OutFile "64thv005.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Winamp

; detect winamp path from uninstall string if available
InstallDirRegKey HKLM \
                 "Software\Microsoft\Windows\CurrentVersion\Uninstall\Winamp" \
                 "UninstallString"

; The text to prompt the user to enter a directory
DirText "Please select your Winamp path below (you will be able to proceed when Winamp is detected):"
# currently doesn't work - DirShow hide

; automatically close the installer when done.
AutoCloseWindow true

; hide the "show details" box
ShowInstDetails nevershow

;--------------------------------

;Pages

Page directory
Page instfiles

;--------------------------------

; The stuff to install

Section ""

  Call QueryWinampPath

  SetOutPath $1
  File "E:\program files\winamp\RSP.dll"

  SetOutPath $1\Plugins
  File "E:\program files\winamp\Plugins\in_usf.dll"


SectionEnd

;--------------------------------

Function .onVerifyInstDir

  ;Check for Winamp installation

  IfFileExists $INSTDIR\Winamp.exe Good
    Abort
  Good:

FunctionEnd

Function QueryWinampPath ; sets $1 with path

  StrCpy $1 $INSTDIR
  
FunctionEnd